import java.util.Scanner;

public class TempoLivre {

    public static void main(String[] args){
        Scanner sc = new Scanner(System.in);

        int dia = 0;
		int	dmax = sc.nextInt();
        
        while(dia++ < dmax ){
            int c = sc.nextInt();
			
            sc.nextLine();
            String[] lines = new String[c+2];//Array que armazena a linha com os horarios e as atividades
											 //Sao "c" atividades, mais o horario inicial(10:00) e final(22:00)
            
            //  Entrada //
			
            lines[0] = "10:00 10:00";//O horario inical
            for(int i = 1; i < c+1; i++){
                lines[i] = sc.nextLine();//Carrega todos os atividades
            }
            lines[c+1] = "22:00 22:00";// horario final
            
			
			// Calcula o Tempo Livre //
			
			/**Calcula os tempos entre atividades comecando pelo tempo entre
			o comeco da atividade de indice 1(a primeira atividade fornecida pelo programa) e o final da atividade de incice 0(10:00)
			ate o comeco da atividade de indice c+1(ultima atividade dada pela entrada) com o ultimo indice(22:00)**/	

            int tmax = 0;//A duracao do maior tempo livre em minutos
			int r = -1;//O indice em que comeca o maior tempo livre
            int aux = 0;//Variavel auxiliar para calcular tempo livre entre atividades
			
            for(int x = 1; x < lines.length; x++){
                aux = 600*(lines[x].charAt(0) - lines[x-1].charAt(6)) + //dezena de hora
                     60*(lines[x].charAt(1) - lines[x-1].charAt(7)) +   //hora
                     10*(lines[x].charAt(3) - lines[x-1].charAt(9)) +   //dezena de minuto
                        (lines[x].charAt(4) - lines[x-1].charAt(10));   //minuto
                if(tmax < aux){//Se o auxiliar for maior ele se torna o tempo maximo, se for igual a primeira hora maxima prevalece
                    tmax = aux;
                    r = x-1;
                }
            }
            
            // Saida //
			
            System.out.println("Dia " + dia + ": o maior periodo livre comeca as "+
							   lines[r].substring(6, 11) + " e dura " + 
							   tmax/60 + " horas e " + tmax%60 + " minutos");
							   
			/** "lines[r].substring(6, 11)" gera uma string com o conteudo da string lines[r], do char de indice 6 ate o char de indice 11.
			Seria o equivalente a colocar os chars de indice 6,7,8,9,10 em uma string e mandar imprimir a string**/
            
        }
    }
}
